Index: trunk/src/world_entities/WorldEntities.am
===================================================================
--- trunk/src/world_entities/WorldEntities.am	(revision 10697)
+++ trunk/src/world_entities/WorldEntities.am	(revision 10698)
@@ -1,3 +1,2 @@
-
 ## THE SUBCLASSES. THESE MUST BE DYNAMICALLY LINKED OR COMPILED IN DIRECTLY
 WorldEntities_SOURCES_ = \
@@ -12,4 +11,6 @@
                 world_entities/npcs/repair_station.cc \
                 world_entities/npcs/attractor_mine.cc \
+		world_entities/npcs/actionbox_enemy.cc \
+		world_entities/npcs/adm_turret.cc \
                 \
                 \
@@ -32,4 +33,8 @@
                 world_entities/weapons/spike_thrower.cc \
                 world_entities/weapons/acid_launcher.cc \
+		world_entities/weapons/rf_cannon.cc \
+                world_entities/weapons/disruptor.cc \
+                world_entities/weapons/nadion_laser.cc \
+                world_entities/weapons/bsp_weapon.cc \
                 \
                 world_entities/projectiles/lbolt.cc \
@@ -47,4 +52,6 @@
                 world_entities/projectiles/spike.cc \
                 world_entities/projectiles/acid_splash.cc \
+		world_entities/projectiles/plasma_pulse.cc \
+                world_entities/projectiles/nadion_blast.cc \
                 \
                 world_entities/projectiles/projectile_weapon.cc \
@@ -158,4 +165,6 @@
                 npcs/repair_station.h \
                 npcs/attractor_mine.h \
+		npcs/actionbox_enemy.h \
+		npcs/adm_turret.h \
                 \
                 environments/environment.h \
@@ -196,4 +205,8 @@
                 weapons/spike_thrower.h \
                 weapons/acid_launcher.h \
+		weapons/rf_cannon.h \
+                weapons/disruptor.h \
+                weapons/nadion_laser.h \
+                weapons/bsp_weapon.h \
                 \
                 projectiles/lbolt.h \
@@ -212,4 +225,6 @@
                 projectiles/spike_ball.h \
                 projectiles/acid_splash.h \
+		projectiles/plasma_pulse.h \
+		projectiles/nadion_blast.h \
                 \
                 projectiles/projectile_weapon.h \
Index: trunk/src/world_entities/creatures/fps_player.cc
===================================================================
--- trunk/src/world_entities/creatures/fps_player.cc	(revision 10697)
+++ trunk/src/world_entities/creatures/fps_player.cc	(revision 10698)
@@ -19,4 +19,6 @@
 #include "interactive_model.h"
 #include "state.h"
+#include "tools/camera.h"
+#include "player.h"
 
 #include "src/lib/util/loading/factory.h"
@@ -51,4 +53,5 @@
 			    ->addMethod("getAbsCoorY", Executor0ret<PNode, lua_State*, float>(&PNode::getAbsCoorY))
 			    ->addMethod("getAbsCoorZ", Executor0ret<PNode, lua_State*, float>(&PNode::getAbsCoorZ))
+			    ->addMethod("displayHUDText", Executor1<FPSPlayer, lua_State*, const std::string&>(&FPSPlayer::displayHUDText))
                        );
 
@@ -95,4 +98,8 @@
   this->bPosBut = false;
   this->bFire = false;
+  this->bFire2 = false;
+  this->changeZoom = true;
+  this->inZoomMode = false;
+  this->changingZoom = false;
 
   this->xMouse = 0.0f;
@@ -116,5 +123,7 @@
   registerEvent(KeyMapper::PEV_RIGHT);
   registerEvent(KeyMapper::PEV_FIRE1);
+  registerEvent(KeyMapper::PEV_FIRE2);
   registerEvent(KeyMapper::PEV_JUMP);
+  registerEvent(KeyMapper::PEV_CROUCH);
   registerEvent(EV_MOUSE_MOTION);
 
@@ -149,5 +158,6 @@
 
   this->getWeaponManager().getFixedTarget()->setParent(&this->cameraNode);
-  this->getWeaponManager().getFixedTarget()->setRelCoor(1000,0,0);
+  this->getWeaponManager().getFixedTarget()->setParentMode(PNODE_ALL);
+  this->getWeaponManager().getFixedTarget()->setRelCoor(10,0,0);
 
 
@@ -179,5 +189,8 @@
 }
 
-
+/**
+ * was probabably designed for setting direction of FPSPlayer
+ * but hey, this connot work like this, can it?
+ */
 void FPSPlayer::setPlayDirection(const Quaternion& quat, float speed)
 {
@@ -186,5 +199,8 @@
 }
 
-
+/**
+ * Resets FPSPlayer stats and freezes its moving directions
+ *
+ */
 void FPSPlayer::reset()
 {
@@ -195,9 +211,13 @@
   this->xMouse = 0.0f;
   this->yMouse = 0.0f;
+  this->inZoomMode = false;
 
   this->setHealth(80);
 }
 
-
+/**
+ * Defines what happens to camera and other important elements when changing
+ * into FPS-view
+ */
 void FPSPlayer::enter()
 {
@@ -206,7 +226,10 @@
   State::getCameraNode()->setParentSoft(&this->cameraNode);
   State::getCameraTargetNode()->setParentSoft(&this->cameraNode);
-
-  this->getWeaponManager().getFixedTarget()->setParent(State::getCameraTargetNode());
-  this->getWeaponManager().getFixedTarget()->setRelCoor(0,0,0);
+  
+  State::getCamera()->setViewMode(Camera::ViewFPS);
+  
+  this->getWeaponManager().getFixedTarget()->setParent(&this->cameraNode);
+  //this->getWeaponManager().getFixedTarget()->setParentMode(PNODE_ALL);
+  //this->getWeaponManager().getFixedTarget()->setRelCoor(100,0,0);
 
   if ( !State::isOnline() )
@@ -216,4 +239,8 @@
 }
 
+/**
+ * Defines what happens if active player leaves FPSPlayer
+ * (basicly hides crosshair and frees camera)
+ */
 void FPSPlayer::leave()
 {
@@ -230,5 +257,5 @@
 void FPSPlayer::tick (float time)
 {
-
+     // Second init-step
   if ( !this->initWeapon )
   {
@@ -239,5 +266,6 @@
     this->getWeaponManager().getParentNode()->setParentMode(PNODE_ROTATE_AND_MOVE);
     this->getWeaponManager().getFixedTarget()->setParent(&this->cameraNode);
-    this->getWeaponManager().getFixedTarget()->setParentMode(PNODE_ROTATE_AND_MOVE);
+    //this->getWeaponManager().getFixedTarget()->setParentMode(PNODE_ROTATE_AND_MOVE);
+    State::getCamera()->setViewMode(Camera::ViewFPS);
 
 
@@ -251,18 +279,74 @@
     }
 
-
-    AABB* box = this->getModelAABB();
-    if( box != NULL)
-    {
+  }
+  // end of second init-step
+  
+  // This box represents the dimension of the used model
+  AABB* box = this->getModelAABB();
+
+  if( box != NULL)
+  {
       float f = 1.0;
+      if( this->bCrouch )
+          f = 0.3*f;
+      
       this->cameraNode.setRelCoor(0, box->halfLength[1] * f, 0);
-//       this->cameraNode.setRelCoor(10, box->halfLength[1] * f, 0);
-
-      float v = 0.1f;
-      this->getWeaponManager().setSlotPosition(0, Vector(-8.0, box->halfLength[1] * v, 1.1));
-      this->getWeaponManager().setSlotPosition(1, Vector(5.0, box->halfLength[1] * v, 0.0));
-    }
-  }
-
+//      this->cameraNode.setRelCoor(10, box->halfLength[1] * f, 0);
+     float v = 0.1f;
+     this->getWeaponManager().setSlotPosition(0, Vector(-8.0, box->halfLength[1] * v, 1.1));
+     this->getWeaponManager().setSlotPosition(1, Vector(5.0, box->halfLength[1] * v, 0.0));
+  }
+  
+  /*
+  if( this->bFire2 )
+  {
+      
+      // to change Zoom on click
+      if( this->changeZoom )
+      {
+          this->changeZoom = false;
+          if( this->inZoomMode )
+          {
+              State::getCamera()->setViewMode(Camera::ViewFPS);
+              this->inZoomMode = false;
+          }
+          else
+          {
+              State::getCamera()->setViewMode(Camera::ViewFPSZoom);
+              this->inZoomMode = true;
+          }
+          
+      }
+      
+  }
+  else
+  {
+      this->changeZoom = true;
+  }*/
+  if( this->bFire2 )
+  {
+      if( this->changeZoom )
+      {
+          if( !this->inZoomMode || this->changingZoom )
+          {
+              this->inZoomMode = true;
+              this->changingZoom = true;
+              float fovy = State::getCamera()->getFovy();
+              if( fovy > 30 )
+                  State::getCamera()->setFovy( fovy - 10*time );
+          }
+          else
+          {
+                State::getCamera()->setViewMode(Camera::ViewFPS);
+                this->inZoomMode = false;
+                this->changeZoom = false;
+          }
+      }
+  }
+  else
+  {
+      this->changeZoom = true;
+      this->changingZoom = false;
+  }
 
   this->getWeaponManager().tick(time);
@@ -301,7 +385,14 @@
     xMouse *= time ;
     yMouse *= time ;
-
-    heading -= xMouse/5.;
-    attitude-= yMouse/5.;
+    
+    float amount;
+    
+    if( this->inZoomMode )
+        amount = 2.;
+    else
+        amount = 5.;
+
+    heading -= xMouse/amount;
+    attitude-= yMouse/amount;
 
 
@@ -346,28 +437,64 @@
     }*/
 
-  velocity *= 100;
+  int speed;
+  if( this->bCrouch )
+      speed = 50;
+  else
+      speed = 100;
+  velocity *= speed;
 
   if( this->getModel( 0) != NULL && this->getModel(0)->isA(InteractiveModel::staticClassID()))
   {
-    if( this->bJump)
-    {
-      if( this->jumpAcceleration < 1.0f)
+      if( this->bJump)
       {
-        this->jumpAcceleration = 300.0f;
-
-        if( ((InteractiveModel*)this->getModel(0))->getAnimation() != JUMP)
-          ((InteractiveModel*)this->getModel(0))->setAnimation(JUMP);
-      }
-    }
-    else if(velocity.len() != 0.0f)
-    {
-      if( ((InteractiveModel*)this->getModel(0))->getAnimation() != RUN)
-        ((InteractiveModel*)this->getModel(0))->setAnimation(RUN);
-    }
-    else
-    {
-      if( ((InteractiveModel*)this->getModel(0))->getAnimation() != STAND)
-        ((InteractiveModel*)this->getModel(0))->setAnimation(STAND);
-    }
+          if( this->jumpAcceleration < 1.0f)
+          {
+              this->jumpAcceleration = 300.0f;
+
+              if( ((InteractiveModel*)this->getModel(0))->getAnimation() != JUMP)
+                  ((InteractiveModel*)this->getModel(0))->setAnimation(JUMP);
+          }
+       }
+       else if(velocity.len() != 0.0f)
+       {
+            if( this->bCrouch )
+            {
+                if( ((InteractiveModel*)this->getModel(0))->getAnimation() != CROUCH_WALK)
+                    ((InteractiveModel*)this->getModel(0))->setAnimation(CROUCH_WALK);
+            }
+            else
+            {
+                if( ((InteractiveModel*)this->getModel(0))->getAnimation() != RUN)
+                    ((InteractiveModel*)this->getModel(0))->setAnimation(RUN); 
+            }
+                 
+       }
+       else
+       {
+           if( this->bCrouch )
+           {
+               if( ((InteractiveModel*)this->getModel(0))->getAnimation() != CROUCH_STAND)
+                   ((InteractiveModel*)this->getModel(0))->setAnimation(CROUCH_STAND);
+           }
+           else
+           {
+               if( ((InteractiveModel*)this->getModel(0))->getAnimation() != STAND)
+                   ((InteractiveModel*)this->getModel(0))->setAnimation(STAND);
+           }
+       }
+       
+       if( this->bFire )
+       {
+           if( this->bCrouch )
+           {
+               if( ((InteractiveModel*)this->getModel(0))->getAnimation() != CROUCH_ATTACK)
+                   ((InteractiveModel*)this->getModel(0))->setAnimation(CROUCH_ATTACK);
+           }
+           else
+           {
+               if( ((InteractiveModel*)this->getModel(0))->getAnimation() != ATTACK)
+                   ((InteractiveModel*)this->getModel(0))->setAnimation(ATTACK);
+           }
+       }
   }
 
@@ -390,12 +517,11 @@
     this->fallVelocity = 0.0f;
   }
-  if((velocity *time).len() < 10.0f) this->shiftCoor( velocity*time );
-  else{	 
+  if((velocity * time).len() < 10.0f) this->shiftCoor( velocity*time );
+  else
+  {	 
 	 velocity.normalize();
 	 velocity *= 10.0f;
 	 this->shiftCoor( velocity );
-       }
-
-
+  }
 
 
@@ -409,4 +535,5 @@
   if( this->aimingSystem != NULL)
     this->aimingSystem->flushList();
+    
 }
 
@@ -426,5 +553,5 @@
 
 /**
- * process
+ * checks events
  */
 void FPSPlayer::process(const Event &event)
@@ -440,4 +567,12 @@
   else if( event.type == KeyMapper::PEV_BACKWARD)
     this->bBackward = event.bPressed; //this->shiftCoor(0,-.1,0);
+  else if( event.type == KeyMapper::PEV_JUMP)
+    this->bJump = event.bPressed;
+  else if( event.type == KeyMapper::PEV_FIRE1)
+    this->bFire = event.bPressed;
+  else if( event.type == KeyMapper::PEV_FIRE2)
+    this->bFire2 = event.bPressed;
+  else if( event.type == KeyMapper::PEV_CROUCH)
+    this->bCrouch = event.bPressed;
   else if( event.type == EV_MOUSE_MOTION)
   {
@@ -445,15 +580,9 @@
     this->yMouse += event.yRel;
   }
-  else if( event.type == KeyMapper::PEV_JUMP)
-  {
-    this->bJump = event.bPressed;
-  }
-  else if( event.type == KeyMapper::PEV_FIRE1)
-  {
-    this->bFire = event.bPressed;
-  }
-}
-
-
+}
+
+/**
+ * respawns FPSplayer
+ */
 void FPSPlayer::respawn( )
 {
@@ -466,5 +595,7 @@
 }
 
-
+/**
+ * Kills the FPSplayer defining its killer
+ */
 void FPSPlayer::destroy( WorldEntity* killer )
 {
@@ -474,2 +605,6 @@
 }
 
+void FPSPlayer::displayHUDText( const std::string& message )
+{
+	State::getPlayer()->hud().notifyUser(message);
+}
Index: trunk/src/world_entities/creatures/fps_player.h
===================================================================
--- trunk/src/world_entities/creatures/fps_player.h	(revision 10697)
+++ trunk/src/world_entities/creatures/fps_player.h	(revision 10698)
@@ -36,4 +36,6 @@
     virtual void tick(float time);
     virtual void draw() const;
+    
+    void displayHUDText( const std::string& message );
 
 
@@ -43,29 +45,35 @@
     void init();
 
-    bool                  bLeft;
-    bool                  bRight;
-    bool                  bForward;
-    bool                  bBackward;
-    bool                  bJump;              //!< jumping
-    bool                  bPosBut;             //!< position button
-    bool                  bFire;              //!< fire button
+    bool                  bLeft;             //!< strafe left
+    bool                  bRight;            //!< strafe right
+    bool                  bForward;          //!< walk forward
+    bool                  bBackward;         //!< walk backward
+    bool                  bJump;             //!< jumping
+    bool                  bPosBut;           //!< position button
+    bool                  bFire;             //!< fire button
+    bool                  bFire2;            //!< alternate fire button
+    bool                  bCrouch;           //!< crouch button
 
-    float                 xMouse;             //!< mouse moved in x-Direction
-    float                 yMouse;             //!< mouse moved in y-Direction
+    float                 xMouse;            //!< mouse moved in x-Direction
+    float                 yMouse;            //!< mouse moved in y-Direction
 
 
-    float                 heading;
-    float                 attitude;
+    float                 heading;           //!< the direction where the player heads to
+    float                 attitude;          //!< defines the camera angle to the x-z-plane
 
-    PNode                 cameraNode;
+    PNode                 cameraNode;        //!< the "eyes" of the player (or call it head if you want)
 
-    float                 fallVelocity;        //!< velocity for falling down
-    float                 jumpAcceleration;    //!< the jump acceleration 
+    float                 fallVelocity;      //!< velocity for falling down
+    float                 jumpAcceleration;  //!< the jump acceleration 
 
     bool                  initWeapon;
+    bool                  changeZoom;        //!< zoom sight of player
+    bool                  inZoomMode;        //!< zoomsight
+    bool                  changingZoom;
 
-    AimingSystem*         aimingSystem;        //!< aiming system of the player
+    AimingSystem*         aimingSystem;      //!< aiming system of the player
 
-    float                 damageTicker;        //!< ticker for dealing damage
+    float                 damageTicker;      //!< ticker for dealing damage
+    
 };
 
Index: trunk/src/world_entities/effects/billboard.cc
===================================================================
--- trunk/src/world_entities/effects/billboard.cc	(revision 10697)
+++ trunk/src/world_entities/effects/billboard.cc	(revision 10698)
@@ -11,4 +11,5 @@
 ### File Specific:
    main-programmer: David Hasenfratz
+   co-programmer: Nicolas Schlumberger
 */
 
@@ -69,4 +70,12 @@
 
   this->texColor = NULL;
+
+  this->pulseMagnitude = .5;
+  this->bPulse = false;
+
+  this->angularSpeed = M_2_PI; //360;
+  this->angle = 0;
+
+  this->setUpdateFunction((*sinf));
 }
 
@@ -113,4 +122,8 @@
 void Billboard::tick(float dt)
 {
+  this->angle += dt * this->angularSpeed;
+  if (this->angle > M_2_PI)
+    this->angle -= M_2_PI;
+//   curMagnitude = updatePulse(this->angle);
 }
 
@@ -145,6 +158,10 @@
   v.normalize();
 
-  v *= sizeX;
-  h *= sizeY;
+  float tmp = 1;
+  if (this->bPulse)
+    tmp += this->pulseMagnitude * sinf(this->angle); //updatePulse(this->angle);
+
+  v *= sizeX * tmp;
+  h *= sizeY * tmp;
 
 //v += this->getAbsCoor();
Index: trunk/src/world_entities/effects/billboard.h
===================================================================
--- trunk/src/world_entities/effects/billboard.h	(revision 10697)
+++ trunk/src/world_entities/effects/billboard.h	(revision 10698)
@@ -26,12 +26,31 @@
     void colorTexture(const Color col);
 
+    //!< Pulsing Capability, changes size of the grid
+    inline void togglePluse () {this->bPulse = !bPulse; };
+    inline void setPulse () { this->bPulse = true; };
+    inline void setPulse ( bool state ) {this->bPulse = state; };
+    inline float getPulse () { return this->bPulse; };
+
+    inline void setPulseMagnitude(float mag) {this->pulseMagnitude = mag; };
+
     virtual void tick(float dt);
     virtual void draw() const;
 
+    inline void setUpdateFunction(float (*updateFct)(float value)) { if( updateFct)  this->updatePulse = updateFct;};
+
   private:
+
+    float (*updatePulse)(float value);
+
     Material*        material;
     Color*           texColor;
     float sizeX;
     float sizeY;
+
+    bool bPulse;
+    float pulseMagnitude;
+    float curMagnitude;
+    float angle;
+    float angularSpeed;
 };
 
Index: trunk/src/world_entities/effects/blink.cc
===================================================================
--- trunk/src/world_entities/effects/blink.cc	(revision 10697)
+++ trunk/src/world_entities/effects/blink.cc	(revision 10698)
@@ -67,5 +67,5 @@
   this->bBoard->setTexture("textures/light/blink.png");
 
-  /// Standard values
+  //!< Standard values
   this->bBoard->setAbsCoor(0, 0, 0);
   // default position if not set in xml
Index: trunk/src/world_entities/effects/explosion.h
===================================================================
--- trunk/src/world_entities/effects/explosion.h	(revision 10697)
+++ trunk/src/world_entities/effects/explosion.h	(revision 10698)
@@ -32,5 +32,7 @@
     virtual void tick (float time);
 
-  private:
+    void setLifeTime( float lifeTime ){ this->lifeTime = lifeTime; }
+
+  protected:
     static FastFactory*        fastFactory;
 
Index: trunk/src/world_entities/effects/wobblegrid.cc
===================================================================
--- trunk/src/world_entities/effects/wobblegrid.cc	(revision 10697)
+++ trunk/src/world_entities/effects/wobblegrid.cc	(revision 10698)
@@ -10,5 +10,5 @@
 
 ### File Specific:
-   main-programmer: David Hasenfratz
+   main-programmer: Marc Schärer
 */
 
Index: trunk/src/world_entities/npcs/actionbox_enemy.cc
===================================================================
--- trunk/src/world_entities/npcs/actionbox_enemy.cc	(revision 10698)
+++ trunk/src/world_entities/npcs/actionbox_enemy.cc	(revision 10698)
@@ -0,0 +1,264 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Christoph Renner
+   co-programmer:
+*/
+
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY
+
+#include "loading/factory.h"
+#include "debug.h"
+#include "loading/load_param.h"
+#include "util/loading/load_param_xml.h"
+#include "state.h"
+#include "player.h"
+#include "playable.h"
+
+#include "actionbox_enemy.h"
+
+ObjectListDefinition(ActionboxEnemy);
+CREATE_FACTORY(ActionboxEnemy);
+
+ActionboxEnemy::ActionboxEnemy(const TiXmlElement* root)
+{
+  PRINTF(0)("ActionboxEnemy\n");
+  
+  this->registerObject(this, ActionboxEnemy::_objectList);
+  this->toList(OM_GROUP_00);
+  
+  this->isActive = true;
+  
+  this->pitch = 0.0f;
+  this->dPitch = 0.0;
+  
+  this->maxSpeed = 30;
+  this->acceleration = 3;
+  this->speed = 0;
+  
+  this->onEscape = false;
+  
+  if ( root )
+    this->loadParams( root );
+}
+
+ActionboxEnemy::~ActionboxEnemy()
+{
+}
+
+void ActionboxEnemy::loadParams(const TiXmlElement* root)
+{
+  WorldEntity::loadParams( root );
+}
+
+void ActionboxEnemy::tick( float dt )
+{
+  this->bFire = false;
+  
+  if ( !State::getPlayer() || !State::getPlayer()->getPlayable() )
+    return;
+  
+  Vector playerDir = State::getPlayer()->getPlayable()->getAbsDir().apply( Vector(1, 0, 0) );
+  Vector dist = this->getAbsCoor() - State::getPlayer()->getPlayable()->getAbsCoor();
+  
+  bool behindPlayer = playerDir.dot( dist ) < 0;
+  
+  if ( behindPlayer )
+    return;
+  
+  myDir = this->getAbsDir();
+  myCoor = this->getAbsCoor();
+  
+  this->pitch += this->dPitch*dt;
+  while ( pitch > 2*PI )
+    pitch -= 2*PI;
+  while ( pitch < 0 )
+    pitch += 2*PI;
+  
+  myDir *= qPitch.inverse();
+  
+  qPitch = Quaternion( pitch, Vector( 1, 0, 0 ) );
+  
+  if ( isActive && State::getActionBox() )
+  {
+    ActionBox* box = State::getActionBox();
+    if ( box->isPointInBox( this->getAbsCoor() ) )
+    {
+      attackPlayer( box, dt );
+    }
+    else
+    {
+      moveTowardsBox( box, dt );
+      onEscape = false;
+    }
+  }
+  
+  myDir *= qPitch;
+  
+  this->setAbsDir( myDir );
+  this->setAbsCoor( myCoor );
+}
+
+void ActionboxEnemy::attackPlayer( ActionBox * box, float dt )
+{
+  if ( !State::getPlayer() || !State::getPlayer()->getPlayable() || !box )
+    return;
+  
+  float distance = (State::getPlayer()->getPlayable()->getAbsCoor() - getAbsCoor() ).len();
+  
+  if ( distance > box->getDepth()/4.0 && !onEscape )
+  {
+    Vector targetPos = State::getPlayer()->getPlayable()->getAbsCoor();
+    Vector targetDir = State::getPlayer()->getPlayable()->getAbsCoor()-this->getAbsCoor();
+    moveTowards( targetPos, targetDir, dt );
+    if ( this->getAbsDir().apply( Vector(1, 0, 0) ).dot(targetDir) > 0.9 )
+    {
+      this->bFire = true;
+      PRINTF(0)("FIRE\n");
+    }
+  }
+  else
+  {
+    if ( !onEscape )
+    {
+      Vector ds = this->getAbsCoor() - State::getPlayer()->getPlayable()->getAbsCoor();
+      float projy = box->getAbsDir().apply( Vector(0, 1, 0) ).dot( ds );
+      float projz = box->getAbsDir().apply( Vector(0, 0, 1) ).dot( ds );
+      this->escapePoint = Vector( 0, projy, projz );
+      this->escapePoint.normalize();
+      this->escapePoint*= 2*box->getWidth_2();
+      PRINTF(0)("ESCAPE\n");
+    }
+    onEscape = true;
+    
+    Vector rEscapePoint = box->getAbsDir().apply(escapePoint);
+    Vector targetPos = State::getPlayer()->getPlayable()->getAbsCoor() + rEscapePoint;
+    Vector targetDir = State::getPlayer()->getPlayable()->getAbsCoor() + rEscapePoint - this->getAbsCoor();
+    moveTowards( targetPos, targetDir, dt );    
+  }
+}
+
+void ActionboxEnemy::moveTowards( Vector targetPos, Vector targetDir, float dt )
+{
+  Quaternion cur = myDir;
+  Quaternion rx( dt, Vector( 0, 0, 1 ) );
+  
+  Quaternion tmp1 = cur * rx;
+  Quaternion tmp2 = cur * rx.inverse();
+  
+  Quaternion dec;
+  if ( tmp1.apply( Vector(1, 0, 0) ).dot(targetDir) > tmp2.apply( Vector(1, 0, 0)).dot(targetDir) )
+    dec = tmp1;
+  else
+    dec = tmp2;
+  
+  float dp = dec.apply( Vector(1, 0, 0) ).dot(Vector(0, 1, 0));
+  if ( dp > -0.9 && dp < 0.9 )
+  {
+    cur = dec;
+  }
+  
+  Quaternion ry( dt, cur.inverse().apply( Vector( 0, 1, 0 ) ) );
+  
+  tmp1 = cur * ry;
+  tmp2 = cur * ry.inverse();
+  
+  if ( tmp1.apply( Vector(1, 0, 0) ).dot(targetDir) > tmp2.apply( Vector(1, 0, 0)).dot(targetDir) )
+    cur = tmp1;
+  else
+    cur = tmp2;
+  
+  myDir = cur;
+  
+  Vector fw = cur.apply( Vector(1, 0, 0) );
+  
+  this->speed += this->acceleration*dt;
+  if ( this->speed > this->maxSpeed )
+    this->speed = this->maxSpeed;
+  this->myCoor += fw*speed*dt;
+}
+
+void ActionboxEnemy::moveTowardsBox( ActionBox * box, float dt )
+{
+    
+  Vector targetPos = box->getAbsCoor() + box->getAbsDir().apply( Vector( 1, 0, 0 ) )*box->getDepth()*0.66f;
+  Vector targetDir = targetPos - myCoor;
+  
+  moveTowards(targetPos, targetDir, dt);
+}
+
+void ActionboxEnemy::draw( ) const
+{
+#if 0
+  Vector fw = this->getAbsDir().apply( Vector( 1, 0, 0 ) );
+  fw.normalize();
+  fw = fw * 100;
+  
+  Vector mp = this->getAbsCoor();
+  Vector op = mp + fw;
+  
+  Vector targetPos = State::getPlayer()->getPlayable()->getAbsCoor();
+  Vector dv = targetPos - this->getAbsCoor();
+  dv.normalize();
+  dv *= 100;
+  dv += mp;
+  
+  Vector spUp = this->getAbsDir().inverse().apply( this->getAbsDir().apply( Vector( 0, 1, 0 ) ) );
+  spUp.normalize();
+  spUp *= 100;
+  spUp += mp;
+  
+  Vector up = fw.cross( dv );
+  up += mp;
+  
+  //PRINTF(0)("DEBUG\n");
+  //mp.debug();
+  //op.debug();
+  
+  glMatrixMode(GL_MODELVIEW);
+  glPushMatrix();
+
+  glPushAttrib(GL_ENABLE_BIT);
+
+  glDisable(GL_LIGHTING);
+  glDisable(GL_TEXTURE_2D);
+  glDisable(GL_BLEND);
+  glLineWidth(2.0);
+  glColor3f(1.0, 0.0, 0.0 );
+  
+  
+  glBegin(GL_LINE_STRIP);
+    glVertex3f(mp.x, mp.y, mp.z);
+    glVertex3f(op.x, op.y, op.z);
+  glEnd();
+  
+  glColor3f(0.0, 1.0, 0.0 );
+  glBegin(GL_LINE_STRIP);
+    glVertex3f(mp.x, mp.y, mp.z);
+    glVertex3f(dv.x, dv.y, dv.z);
+  glEnd();
+  
+  glColor3f(0.0, 0.0, 1.0 );
+  glBegin(GL_LINE_STRIP);
+    glVertex3f(mp.x, mp.y, mp.z);
+    glVertex3f(up.x, up.y, up.z);
+  glEnd();
+  
+  glColor3f(1.0, 1.0, 1.0 );
+  glBegin(GL_LINE_STRIP);
+    glVertex3f(mp.x, mp.y, mp.z);
+    glVertex3f(spUp.x, spUp.y, spUp.z);
+  glEnd();
+
+  glPopMatrix();
+#endif
+  WorldEntity::draw();
+}
Index: trunk/src/world_entities/npcs/actionbox_enemy.h
===================================================================
--- trunk/src/world_entities/npcs/actionbox_enemy.h	(revision 10698)
+++ trunk/src/world_entities/npcs/actionbox_enemy.h	(revision 10698)
@@ -0,0 +1,45 @@
+
+#ifndef _NPC_H
+#define _NPC_H
+
+#include "world_entity.h"
+#include "world_entities/weapons/weapon_manager.h"
+#include "track/action_box.h"
+
+class ActionboxEnemy : public WorldEntity
+{
+  ObjectListDeclaration(ActionboxEnemy);
+
+  public:
+    ActionboxEnemy(const TiXmlElement* root = NULL);
+    virtual ~ActionboxEnemy ();
+  
+    virtual void tick(float dt);
+    virtual void draw() const;
+
+    virtual void loadParams(const TiXmlElement* root);
+   
+  private:
+    bool  isActive;
+    float pitch;      // rotate angle around x-axix
+    float dPitch;     // change pitch += dPitch*dt
+    Quaternion qPitch;
+    
+    float acceleration;
+    float maxSpeed;
+    float speed;
+    
+    Quaternion myDir;
+    Vector     myCoor;
+    
+    bool       bFire;
+    
+    Vector     escapePoint;
+    bool       onEscape;
+    
+    void attackPlayer( ActionBox* box, float dt );
+    void moveTowardsBox( ActionBox* box, float dt );
+    void moveTowards( Vector targetPos, Vector targetDir, float dt );
+};
+
+#endif
